var TAG = "ele-exp/qti/:";
var $moreImg;
var $container;
var $titleBox;
var $resizeBox;
var hasTitle = false;
var screenHeight = window.innerHeight || document.documentElement.clientHeight ||screen.height;
function containerResize() {
    if (JsDataBridgeApi.isDismissBottomScrollArrowhead()) {
        return;
    }
    console.log(TAG + 'containerResize');
    $moreImg = $(document.getElementsByClassName('more'));
    $container = $(document.getElementsByClassName('nqti-composite-body'));
    $titleBox = $(document.getElementsByClassName('nqti-composite-title'));
    if (!$container || !$container.length) {
        $container = $(document.body)
        $resizeBox = $('._qti-player')
    } else {
        $resizeBox = $container;
    }
    if ($titleBox && $titleBox.length > 0) {
        hasTitle = true;
        resizeCallback();
        $resizeBox.resize(function() {
          resizeCallback();
        })
        $titleBox.resize(function(){
         resizeCallback()
        })
    } else {
        resizeCallback();
        $resizeBox.resize(function() {
          resizeCallback();
        })
    }
}
function resizeCallback() {
    var containerHeight = $container[0].scrollHeight;
    var condition = containerHeight > screenHeight;
    if (hasTitle) {
        var titleBoxHeight = $titleBox.height();
        condition = containerHeight > screenHeight - titleBoxHeight
    }
    if (condition) {
        $moreImg.show();
    } else {
        $moreImg.hide();
    }
}
function onscroll() {
    var $moreImg = $(document.getElementsByClassName('more'));
    var containerHeight = $container[0].scrollHeight;
    var condition = $container.scrollTop() + screenHeight >= containerHeight - 3;
//    console.log(TAG + $container.attr('class'))
//     console.log(TAG + 'scrollTop：'+ $container.scrollTop() + ',screenHeight:' +screenHeight + ',containerHeight:' + containerHeight );
    if (hasTitle) {
        var titleBoxHeight = $titleBox.height();
        condition = $container.scrollTop() + (screenHeight - titleBoxHeight) >= containerHeight - 3;
    }
    if (condition) {
        $moreImg.hide();
    } else {
        $moreImg.show();
    }
}
$('#qtiplayer-view').on('touchstart', function(){
   if ($container) {
       $container.off('scroll').on('scroll', onscroll)
       if (!document.body.onscroll) {
           document.body.onscroll=onscroll
       }
       $('#qtiplayer-view').off('touchstart')
   }
   });
