DROP TABLE course_query_list;
CREATE TABLE course_query_list(
    _id TEXT,
    title TEXT,
    pic_id TEXT,
    pic_url TEXT,
    video_id TEXT,
    video_url TEXT,
    user_suit TEXT,
    description TEXT,
    total_time INTEGER,
    create_time TEXT,
    total INTEGER,
    PRIMARY KEY(_id)
);
DROP TABLE course_info;
CREATE TABLE course_info(
    _id TEXT,
    user_id TEXT,
    title TEXT,
    pic_id TEXT,
    pic_url TEXT,
    video_id TEXT,
    video_url TEXT,
    user_count INTEGER,
    user_suit TEXT,
    description TEXT,
    course_status INTEGER,
    total_time INTEGER,
    effective_time INTEGER,
    course_regist_type INTEGER,
    user_regist_status INTEGER,
    resource_type_info TEXT,
    video_count INTEGER,
    document_count INTEGER,
    exercise_count INTEGER,
    exam_count INTEGER,
    single_resource INTEGER,
    limit_access_count INTEGER,
    available_access_count INTEGER,
    regist_start_time TEXT,
    regist_end_time TEXT,
    course_start_time TEXT,
    course_end_time TEXT,
    status_code INTEGER,
    appraise_total_number INTEGER,
    appraise_avg_star REAL,
    share_weblink TEXT,
    PRIMARY KEY(_id,user_id)
);
DROP TABLE course_catalog;
CREATE TABLE course_catalog(
    _id TEXT,
    title TEXT,
    sort_num INTEGER,
    resource_flag INTEGER,
    children TEXT,
    resource_list TEXT,
    last_study_resource_type TEXT,
    last_study_resource TEXT,
    PRIMARY KEY(_id)
);