DROP TABLE offline_course_info;
CREATE TABLE offline_course_info(
    _id TEXT,
    user_id TEXT,
    project_id TEXT,
    allow_room_multiple_choose BOOLEAN,
    allow_room_notify BOOLEAN,
    notify_advance_time INTEGER,
    notify_advance_unit INTEGER,
    total_room_count INTEGER,
    enable_room_count INTEGER,
    is_any_room_user BOOLEAN,
    is_teacher BOOLEAN,
    has_sign_point BOOLEAN,
    PRIMARY KEY(_id,user_id)
);

DROP TABLE offline_course_screens;
CREATE TABLE offline_course_screens(
    _id TEXT,
    user_id TEXT,
    total TEXT,
    items TEXT,
    PRIMARY KEY(_id,user_id)
);

DROP TABLE sign_point_data;
CREATE TABLE sign_point_data(
    _id TEXT,
    user_id TEXT,
    project_id TEXT,
    name TEXT,
    type INTEGER,
    sign_config_id TEXT,
    sign_start_time TEXT,
    sign_end_time TEXT,
    location TEXT,
    longitude TEXT,
    latitude TEXT,
    detail_location TEXT,
    precision_range INTEGER,
    enable BOOLEAN,
    h5_url TEXT,
    sign_success_count INTEGER,
    PRIMARY KEY(_id,user_id)
);